class PointWithColor_4 extends Point2DArray implements Color {
    private ColorInt c;

    public PointWithColor_4(Point2D p, Color c) {
	super(p.getX(), p.getY());
	this.c = new ColorInt(c.getR(), c.getG(), c.getB(), c.getA());
    }
    public PointWithColor_4(double x, double y, ColorInt c) {
	super(x, y);
	this.c = (ColorInt)c.clone();
    }
    public Object clone() {
	return new PointWithColor_4(getX(), getY(), c);
    }
    public boolean equals(Object o) {
	if ( o instanceof PointWithColor_4 ) {
	    PointWithColor_4 pc = (PointWithColor_4) o;
	    return super.equals(pc) && c.equals(pc.c);
	}
	if ( o instanceof Point2D )
	    return super.equals(o);
	if ( o instanceof Color )
	    return o.equals (c);
	return false;		         
    }
    public String toString() {
	return super.toString() + " with color " + c;
    }
    public int getR() {
	return c.getR();
    }
    public int getG() {
	return c.getG();
    }
    public int getB() {
	return c.getB();
    }
    public int getA() {
	return c.getA();
    }
    public void setR(int b) {
	c.setR(b);
    }
    public void setG(int b) {
	c.setG(b);
    }
    public void setB(int b) {
	c.setB(b);
    }
    public void setA(int b) {
	c.setA(b);
    }
    public void set(int r, int g, int b, int a) {
	c.set(r, g, b, a);
    }
}
